//==========================================================================
//  LCR V1.0
//  xjw01  2011.10
//==========================================================================
//==========================================================================
#define uchar unsigned char
#define uint  unsigned int
#define ulong  unsigned long
#include <reg52.h>
#include <math.h>

//==========================================================================
// ĿLCD1602 
// Ҫ㣺
//     LCD1602 ٶƬеٶȿ죬ΪٶȲ
//     ƥɵʧܡˣ֮ǰӦ׼ȷlcd_delay() ʱ
//     ׼ȷʱעеҪӦѭÿ
//     ʱֲָָУͬʱ㹻ʱ
// Ӳӣ
//     Ҫ9ߣԴ27źߡźеĽӿڶ塣
//     עLCD1602ȶԵĵڣʾ
// ƣΰ,,2010.12
//==========================================================================
sbit lcd_RS = P0^6; //λ,01
sbit lcd_RW = P0^5; //дλ,0д1
sbit lcd_EN = P0^4; //ʹλ,½ش
sbit lcd_D4 = P0^3; //ݶ˿D4
sbit lcd_D5 = P0^2; //ݶ˿D5
sbit lcd_D6 = P0^1; //ݶ˿D6
sbit lcd_D7 = P0^0; //ݶ˿D7
//==========================================================================
void lcd_delay(int n){ //LCDרʱ
  //32MHzƵ£Լѭ3000ӳ1
  int i,j;
  if(n<0)    { for(i=0;i< 30;i++); return; } //10us
  if(n== 0)  { for(i=0;i<150;i++); return; } //50us
  for(;n;n--){ for (j=0;j<3000;j++);       } //n
}
//==========================================================================
void lcd_B(char f, uchar c, char t){ //ʽӿLCD7
  //f=0д, f=1дRAM, f=2RAM, f=3RAM
  lcd_EN = 0;
  lcd_RS = f%2;
  lcd_RW = f/2%2;
  //λ
  lcd_D4 = c & 16;
  lcd_D5 = c & 32;
  lcd_D6 = c & 64;
  lcd_D7 = c & 128;
  lcd_EN = 1;  lcd_delay(-1);  lcd_EN = 0; //ʹ
  if(f==4) { lcd_delay(t); return; }
  //λ
  lcd_D4 = c & 1;
  lcd_D5 = c & 2;
  lcd_D6 = c & 4;
  lcd_D7 = c & 8;
  lcd_EN = 1;  lcd_delay(-1);  lcd_EN = 0; //ʹ
  lcd_delay(t);  //ͬ,Ӧʱ䲻ͬ,Ҫ2ms
}
//==========================================================================
void lcd_init(){ //LCD1602 ʼ
  //ģʽ9裬ʼʱϳԼ65msʱ޲ɼ
  lcd_delay(20); //lcd֮ǰʱ15msֱVDD4.5V
  lcd_B(4, 0x30, 9); //8ģʽ,ʱ4.1ms
  lcd_B(4, 0x30, 5); //8ģʽ,ʱ100us
  lcd_B(4, 0x30, 5); //8ģʽ,ֲδָʱ
  lcd_B(4, 0x20, 5); //ģʽ
  lcd_B(0, 0x28, 5); //ģʽ˫ʾ
  lcd_B(0, 0x0C, 5); //ʾ
  lcd_B(0, 0x80, 5); //RAMָ붨λ
  lcd_B(0, 0x01, 5); //ʼLCD
}
//==========================================================================
//=========================ܳú=================================
void lcd_cls()         { lcd_B(0, 0x01+0, 2);  } //
void lcd_cur0()        { lcd_B(0, 0x0C+0, 0);  } //ع
void lcd_goto1(uchar x){ lcd_B(0, 0x80+x, 0);  } //DDRAMַ,1xλ
void lcd_goto2(uchar x){ lcd_B(0, 0xC0+x, 0);  } //DDRAMַ,2xλ
void lcd_putc(uchar d) { lcd_B(1, 0x00+d, 0);  } //ַ
void lcd_puts(uchar *s){ for(; *s; s++) lcd_B(1,*s,0); } //ִ

//==========================================================================
//===============================ʱ===================================
void delay(uint loop) { uint i; for(i=0;i<loop;i++); } //ʱ
void delay2(uint k)   { for(;k>0;k--) delay(10000);  } //ʱ,k=100ԼӦ1

//==========================================================================
//=================================ADת===================================
sfr P1ASF = 0x9D;     //P1ΪģڼĴ(ʹ),λΪ1Ч
sfr ADC_CONTR = 0xBC; //A/DתƼĴ
sfr ADC_res   = 0xBD; //A/DתĴ
sfr ADC_resl  = 0xBE; //A/DתĴ

void set_channel(char channel){
 P1ASF = 1<<channel;
 ADC_CONTR = channel+128; //λǵԴ,3λͨѡ
 delay(1); //״δ򿪵ԴӦӳ٣ʹȶ
}
uint getAD2(){
 ADC_CONTR |= 0x08;             //00001000,ADC_START=1A/D ת
 while ( !(ADC_CONTR & 0x10) ); //ȴA/Dת(ADC_FLAG==0)
 ADC_CONTR &= 0xE7;             //11100111,ADC_FLAG=0, ADC_START=0رA/D ת
 return ADC_res*4 + ADC_resl;
}
/*
uchar get_AD(){
 ADC_CONTR |= 0x08;             //00001000,ADC_START=1A/D ת
 while( !(ADC_CONTR & 0x10) );  //ȴA/Dת(ADC_FLAG==0)
 ADC_CONTR &= 0xE7;             //11100111,ADC_FLAG=0, ADC_START=0رA/D ת
 return ADC_res;
}
*/
uint getAD10() reentrant { //10β
 char i;
 uint c = 0;
 for(i=0;i<10;i++) c += getAD2();
 return c;
}


//==========================================================================
//==================================EEPROWƫ==============================
sfr IAP_data  = 0xC2;
sfr IAP_addrH = 0xC3;
sfr IAP_addrL = 0xC4;
sfr IAP_cmd   = 0xC5;
sfr IAP_trig  = 0xC6;
sfr IAP_contr = 0xC7;
/********************
дֽʱԽԭе1Ϊ0޷0Ϊ1ֻʹò0Ϊ1
Ӧע⣬Ὣ
*********************/
void saEEP(){ //EEP
 IAP_cmd = 0;      //ر
 IAP_contr = 0;    //EEPROM
 IAP_trig = 0;
 IAP_addrL = 255; //öȡַĵֽڣַıҪ
 IAP_addrH = 255; //öȡַĸֽڣַıҪ
}
uchar readEEP(uint k){ //ȡ
 IAP_addrL = k;    //öȡַĵֽڣַıҪ
 IAP_addrH = k>>8; //öȡַĸֽڣַıҪ
 IAP_contr = 0x81; //õȴʱ䣬1MHzȡ72Mȡ63Mȡ56Mȡ412Mȡ320Mȡ224Mȡ130Mȡ0ǰ1ʾIAP
 IAP_cmd = 1;      //ȡֵ1дȡ2ȡ3ʱֽߥ
 IAP_trig = 0x5A;  //5A
 IAP_trig = 0xA5;  //5AA5
 saEEP(); //
 return IAP_data;
}
void writeEEP(uint k, uchar da){ //д
 IAP_data = da;    //
 IAP_addrL = k;    //öȡַĵֽڣַıҪ
 IAP_addrH = k>>8; //öȡַĸֽڣַıҪ
 IAP_contr = 0x81; //õȴʱ䣬1MHzȡ72Mȡ63Mȡ56Mȡ412Mȡ320Mȡ224Mȡ130Mȡ0ǰ1ʾIAP
 IAP_cmd = 2;      //ȡֵ1дȡ2ȡ3ʱֽߥ
 IAP_trig = 0x5A;  //5A
 IAP_trig = 0xA5;  //5AA5
 saEEP(); //
}
void eraseEEP(uint k){ //
 IAP_addrL = k;    //öȡַĵֽڣַıҪ
 IAP_addrH = k>>8; //öȡַĸֽڣַıҪ
 IAP_contr = 0x81; //õȴʱ䣬1MHzȡ72Mȡ63Mȡ56Mȡ412Mȡ320Mȡ224Mȡ130Mȡ0ǰ1ʾIAP
 IAP_cmd = 3;      //ȡֵ1дȡ2ȡ3ʱֽߥ
 IAP_trig = 0x5A;  //5A
 IAP_trig = 0xA5;  //5AA5
 saEEP(); //
}

xdata struct Ida{
 char zo[3];//Ƶµֵ
 char j1;   //λ(3)
 char j2;   //λ(10)
 char J[4];  //λ(V/I任)
 char R[4]; //±۵(20,1k,10k,100k)
 char g1;   //(3)
 char g2;   //(10)
} cs;

void cs_RW(char rw){
 uchar i,*p = &cs;
 if(rw){
  eraseEEP(0);
  for(i=0;i<sizeof(cs);i++) writeEEP(i,p[i]);
 }else{
  for(i=0;i<sizeof(cs);i++) p[i]=readEEP(i);
 }
}


//==========================================================================
//==================================LCR===============================
//==========================================================================
sfr P1M1=0x91; //P1˿üĴ
sfr P1M0=0x92; //P1˿üĴ
sfr P0M1=0x93; //P0˿üĴ
sfr P0M0=0x94; //P0˿üĴ
sfr P2M1=0x95; //P2˿üĴ
sfr P2M0=0x96; //P2˿üĴ
sfr P3M1=0xB1; //P3˿üĴ
sfr P3M0=0xB2; //P3˿üĴ


sbit spk=P2^3; //
sbit Kb=P2^1;  //̿B
sbit Ka=P2^2;  //̿A
sbit DDS2=P1^2;//෽
sbit K3=P1^7;
sbit K4=P1^6;
sbit K5=P1^5;  //7.8kHz˲
sbit K6=P1^4;
sbit K8=P2^0;  //100Hz˲
xdata uchar menu=1,menu2=0; //˵

//==============ַʾ====================
#define digW 4 //ʾλ
void lcd_putp(float a,float b,char bo,char n, float qmin){ //λʾ,nǵλ,qminСλȨֵ(޶Ч)
  code uchar dwB[] = {'p','n','u','m','o','k','M','G'}; //λ
  char i,j, c=0, h=digW-1, fh[2]={' ','+'};
  long d,q,Q=1; //DλȨ
  float f,g=1;
  if(a<0) fh[0] = '-', a = -a;
  if(b<0) fh[1] = '-', b = -b;
  if(a>b) f = a; else f = b;
  if(qmin) {
    a += qmin/2, a -= fmod(a,qmin)-qmin/1000;
    b += qmin/2; b -= fmod(b,qmin)-qmin/1000;
  }
  for(i=1;i<digW;i++) Q *= 10;
  for(i=0;i<3;i++){ if(f*g >= 1000) g/=1000, c++; } //3λΪλƶС,
  for(i=0;i<n;i++){ if(f*g < 1)     g*=1000, c--; } //3λΪλƶС,
  for(i=1;i<digW && f*g<Q;i++) g*=10,h--;           //ƶС㣬ʹ֮
  for(i=0;i<2;i++){
   if(i) d = b*g;          //ȡʵ
   else  d = a*g;          //ȡ鲿
   q = Q;
   lcd_putc(fh[i]);        //ʾ
   for(j=0; j<digW; j++){  //
    lcd_putc(d/q+48);      //
    if(j==h) lcd_putc('.');//С
    d %= q, q /= 10;  
   }
   if(!bo) break;     //ʾ鲿
  }
  lcd_putc(dwB[c+4]); //λ
}
void lcd_putf(float a, char n, float qmin) //λʾ,nǵλ
  { lcd_putp(a,0,0,n,qmin); }
void lcd_int(uint a,char w){ //ʾ
  char i=0, s[5] = {' ',' ',' ',' ',' '};
  for(;a;i++){ s[i] = a%10+48, a /= 10; }
  for(;w;w--) lcd_putc(s[w-1]);
}




//==============ƵźDDS====================
//PCAؼĴ
sfr CMOD = 0xD9;   //ԴѡƵ
sfr CH = 0xF9;     //PCAļ
sfr CL = 0xE9;     //PCAļ
sfr CCON = 0xD8;   //PCAƼĴ
sfr CCPAM0 = 0xDA; //PCAģ0ģʽĴ
sfr CCPAM1 = 0xDB; //PCAģ1ģʽĴ
sfr CCAP0L = 0xEA; //ģ0Ĵλ
sfr CCAP0H = 0xFA; //ģ0Ĵλ

sbit PPCA  = IP^7;   //PCAжȼ
sbit CCF0  = CCON^0; //PCAģ0жϱ־
sbit CCF1  = CCON^1; //PCAģ1жϱ־
sbit CR = CCON^6;    //PCAʹ

void PWM_init(){ //PCAΪPWM
  CMOD = 2;   //0000 0010 Դѡ,Դȡfosc/2
  CL = CH = 0;
  CCAP0L = CCAP0H = 192; //ռձΪ25%
  //CCPAM0=0x42;//0100 0010,PCAģ0ΪPWMģʽ,ж
  CCPAM0=0x53;//0101 0011,PCAģ0ΪPWMģʽ,жϣ½ж
  PPCA = 1;   //ж
  //CR = 1;   //ʼ
  EA = 1;     //ж
}

uint ph=0, phM=256, feq=1000; //λ,phMλֵ
xdata float feqX=1000; //ʵƵ
uchar code sinB[256]={
 //ѯвװֵжϲ
 255,255,255,255,255,255,254,254,253,252,252,251,250,249,248,247,246,245,243,242,240,239,237,236,234,232,230,229,227,225,222,220,
 218,216,214,211,209,206,204,201,199,196,194,191,188,185,183,180,177,174,171,168,165,162,159,156,153,150,147,144,140,137,134,131,
 128,125,122,119,116,112,109,106,103,100, 97, 94, 91, 88, 85, 82, 79, 76, 73, 71, 68, 65, 62, 60, 57, 55, 52, 50, 47, 45, 42, 40,
  38, 36, 34, 31, 29, 27, 26, 24, 22, 20, 19, 17, 16, 14, 13, 11, 10,  9,  8,  7,  6,  5,  4,  4,  3,  2,  2,  1,  1,  1,  1,  1,
   1,  1,  1,  1,  1,  1,  2,  2,  3,  4,  4,  5,  6,  7,  8,  9, 10, 11, 13, 14, 16, 17, 19, 20, 22, 24, 26, 27, 29, 31, 34, 36,
  38, 40, 42, 45, 47, 50, 52, 55, 57, 60, 62, 65, 68, 71, 73, 76, 79, 82, 85, 88, 91, 94, 97,100,103,106,109,112,116,119,122,125,
 128,131,134,137,140,144,147,150,153,156,159,162,165,168,171,174,177,180,183,185,188,191,194,196,199,201,204,206,209,211,214,216,
 218,220,222,225,227,229,230,232,234,236,237,239,240,242,243,245,246,247,248,249,250,251,252,252,253,254,254,255,255,255,255,255
};
uchar code fbB[256]={ //DDSѯ
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
};
uchar chuX=0; //DDS
void PCAinter(void) interrupt 7 {//PCAж
  uchar x,y;
  CCF0=0; //ж,ⷴж
  x = ph >> 8;     //ضλۼ,ȡ8λ
  y = x + chuX;    //λ
  CCAP0H = sinB[x];//DDS
  DDS2 = fbB[y];   //DDS
  ph += phM;       //λۼ
}
void setDDS(uint f){ //οʱc=(fosc/2)/256=32000000/2/256=62500,Ƶf=c*phM/2^16
 feq = f;
 phM=f*65536.0/62500; //phM=f*2^16/62500
 feqX = 62500.0*phM/65536; //ʵƵ
 ph = 0;              //ƵʱʹζԳ
 if(!f) CR=0; else CR=1;
}

//λƺ
xdata char xw=0; //λ
void set90(char k){ //÷λ
  k %= 4;
  if(k<0) k += 4;
  if(k==0) chuX=0;   //0
  if(k==1) chuX=64;  //90
  if(k==2) chuX=128; //180
  if(k==3) chuX=192; //270
  xw = k;
}
void set902() { set90(xw+1); } //λ

//==============̿ƺ====================
xdata char rng=1; //
void setRng(char k){//л
 if(k==0) Ka=0,Kb=0; //100ŷ
 if(k==1) Ka=0,Kb=1; //1kŷ
 if(k==2) Ka=1,Kb=0; //10kŷ
 if(k==3) Ka=1,Kb=1; //100kŷ
 rng = k;
}
void setRng2(){ setRng( (rng+1)%4); } //̲

//==============ƺ====================
char curGain=1; //ǰ
void setGain(char k){ //õ·
  if(k>3) k=3;
  if(k<0) k=0;
  if(k==0) K4=0,K6=0; //1
  if(k==1) K4=0,K6=1; //3
  if(k==2) K4=1,K6=0; //10
  if(k==3) K4=1,K6=1; //30
  curGain = k;
}
void setGain2(){ setGain((curGain+1)%4); }


//==============LCR====================
xdata int Vxy[4]={0,0,0,0};  //Vxy[Vx1,Vy1,Vx2,Vy2]
xdata char Sxw[4]={0,1,0,1}; //ȷλ
xdata char Vga[4]={1,1,1,1}; //±¼
xdata uchar tim=0,tims=0;
xdata char pau=0; //ͣԶת
#define Vfull 9600
#define gad (9600/30)
uchar mT = 6; //ٶ,mTȡֵΪ61224ʱβȡƽ
//==============Ƶ====================
xdata char feqK=1; //Ƶ
void setF(char k){
  if(k==-1){ //
    k = 0;
    if(feq==100)  k=1;
    if(feq==1000) k=2;
    if(feq==7813) k=0;
  }
  feqK = k;
  if(k==0) { setDDS(100);   K5=0; K8=1; mT=12; } //Ϊ100Hz
  if(k==1) { setDDS(1000);  K5=0; K8=0; mT=6;  } //Ϊ1kHz
  if(k==2) { setDDS(7813);  K5=1; K8=0; mT=6;  } //Ϊ7.8125kHz
  TH1 = 47, TL1 = 171; //Ϊ20ms
  tims = 0;
  tim = 0;
  ph = 0;
}
int absMax(int a,int b){ //ȡֵ
  if(a<0) a = -a;
  if(b<0) b = -b;
  if(b>a) a = b;
  return a;
}
#define avn 4 //ƽ޸
xdata float vq[3][avn]; //ݻ棬ƽ
void LCRcalc(int *v,char *g){ //LCR
  code float ga[4] =  {  1,   3,   9,  27 }; //
  code float dwR[4] = { 20, 1e3, 1e4, 1e5 }; //
  xdata int g12 = (int)cs.g1+cs.g2;          //󲹳
  xdata int j12 = (int)cs.j1+cs.j2;          //λ󲹳
  xdata float JD = 0,cJD, G = 0; //
  xdata float a,b,c,e;
  char i;
  a = +( 1.0*v[2]*v[2] + 1.0*v[3]*v[3] );
  b = -( 1.0*v[0]*v[2] + 1.0*v[1]*v[3] );
  c = -( 1.0*v[2]*v[1] - 1.0*v[0]*v[3] );
  a *= ga[g[0]] / ga[g[2]];
  a /= dwR[rng]*(1+cs.R[rng]/10000.0); //±۵ֵ

  //ɿ浥Ԫλ
  if(g[0] == 1) JD += cs.j1,  G += cs.g1;
  if(g[0] == 2) JD += cs.j2,  G += cs.g2;
  if(g[0] == 3) JD += j12,    G += g12;
  if(g[2] == 1) JD -= cs.j1,  G -= cs.g1;
  if(g[2] == 2) JD -= cs.j2,  G -= cs.g2;
  if(g[2] == 3) JD -= j12,    G -= g12;
  JD -= cs.J[rng];
  JD *= feqX/7813/1000;
  cJD = 1 - JD*JD/2;
  a *= 1+G/10000;   //油
  e = b*cJD - c*JD; //λ
  c = b*JD + c*cJD; //λ
  b = e;
  //
  for(i=1;i<avn;i++){
   vq[0][i] = vq[0][i-1];
   vq[1][i] = vq[1][i-1];
   vq[2][i] = vq[2][i-1];
  }
  vq[0][0]=a, vq[1][0]=b, vq[2][0]=c;
}

void timerInter1(void) interrupt 3 {//T1ж,LCRݲɼ
  char g; int c=0;
  tims++;
  if(tims>=mT) tims = 0, tim++, c = 1;
  if(tim>=4) tim=0;
  if(pau) return;
  if(c){ //timλ
   c = getAD10();    //ȡѹֵ
   c -= cs.zo[feqK];
   Vxy[tim] = xw<2 ? c : -c; //浱ǰѹ
   Vga[tim] = curGain;       //浱ǰ
   Sxw[tim] += c<0 ? 2 : 0;  //λת(Ԥ´ελֵ)
   Sxw[tim] %= 4;
   if(tim==1||tim==3){ //±л
     //ѹģֵܷӦ˷ŵȣлжϵģֵ
	 if(tim==1) K3=1, c = absMax(Vxy[2],Vxy[3]), g=Vga[2]; //л±
	 if(tim==3) K3=0, c = absMax(Vxy[0],Vxy[1]), g=Vga[0]; //лϱ
     if(c>Vfull) g--;
     else if(c<gad*1 ) g += 3; //27
	 else if(c<gad*3 ) g += 2; //9
	 else if(c<gad*9)  g++;    //3
	 setGain(g);
   }
   set90( Sxw[ (tim+1)%4 ] ); //λת
   LCRcalc(Vxy,Vga);
  }
}

void showR(char binLian){ //ʾLCR
  char i;
  xdata float a=0,b=0,c=0,e,w;
  for(i=0;i<avn;i++)
    a += vq[0][i]/avn,
    b += vq[1][i]/avn,
    c += vq[2][i]/avn;

  //ѧʾ  if(!a) { lcd_cls(); lcd_puts("DIV 0"); return; }
  w = 2*3.1415926*feqX;
  lcd_goto2(0);     //ʾƵ
  if(feq==100)  lcd_putc('A');
  if(feq==1000) lcd_putc('B');
  if(feq==7813) lcd_putc('C');
  lcd_putc(rng+49); //ʾ
  if(binLian){ //
    e = (b*b+c*c)/a;
    lcd_goto1(0);
    lcd_puts("Zp");
	lcd_putf(e/b, 1, 1e-4); //ʾ迹,ʾŷ
	lcd_putf(e/c, 1, 1e-4); //ʾ迹,ʾŷ
    lcd_goto2(2);
    if(c<0) { lcd_putf(-c/e/w, 4, 1e-14); lcd_putc('F'); } //ʾCֵ,ʾpF
    else    { lcd_putf(+e/c/w, 2, 1e-8 ); lcd_putc('H'); } //ʾLֵ,ʾuH
  }else{ //
    e = a;
    lcd_goto1(0);
    lcd_puts("Zs");
	lcd_putp(b/e, c/e, 1, 1, 1e-4); lcd_putc(244); //ʾ迹,ʾŷ
    lcd_goto2(2);
    if(c<0) { lcd_putf(-e/c/w, 4, 1e-14); lcd_putc('F'); } //ʾCֵ,ʾpF
    else    { lcd_putf(+c/e/w, 2, 1e-8 ); lcd_putc('H'); } //ʾLֵ,ʾuH
  }
  if(b){ c = fabs(c/b); if(c>999) c=999; } //Q
  else c = 999;
  lcd_putf(c,0,0); //ʾQ
}
//void timerInter(void) interrupt 1 {}//T0ж

main(){
 uchar i=0,kn=0,key=0;
 uchar dispN=0; //ʾɨ
 uchar spkN=0;  //ʱ
 uint nn=0;
 uchar binLian=0;

 lcd_init(); //ʼLCD
 lcd_cur0(); //ع
 lcd_puts("LCR 2.0");
 lcd_goto2(0);
 lcd_puts("XJW Putian,2011");
 delay2(80); //ʱ
 cs_RW(0);   //EEPROM

 TCON=0, TMOD=0x12; //T0ΪԶװʱT1Ϊʱ
 TH1 = 0, TL1 = 0;
 TR1=1;  //T1ʼ
 TR0=0;  //T0ͣ
 ET1=1;  //T1ж
 ET0=1;  //T1ж
 EA=1;   //ж
 PT0=1;  //ȼ


 set_channel(0); //ADתͨ
 P2M0 = 0xFF;    //P2.01234567Ϊ
 P1M0 = 0xFC;    //P1.234567Ϊƻ
 P1M1 = 0x03;    //P1.0Ϊ迹
 P2 = 0x0F;
 


 PWM_init();//DDSʼ
 set90(2);  //ʼλ
 setRng(1); //ʼ
 setGain(1); //ʼ
 setF(1);    //DDSʼΪ1kHz

 while(1){
  //ʾdisp
  nn++;
  //ɨ
  key = ~P3;
  if(key&&kn<255) kn++; else kn=0;
  for(i=0;key;i++) key/=2; key=i;
  if(kn==4) spkN=10; else key=0;   //һʱkeyЧspkNʱ
  if(spkN) spkN--, spk=0; else spk=1; //̷
  //˵ϵͳ
  if(key==8){//˵
    lcd_cls();    lcd_puts("Menu:  1 LCR");
    lcd_goto2(0); lcd_puts("3 Test,7 Set");
    menu=0; key=0;
  }
  if(menu>=1 && menu<=4){
    if(key==7) setRng2(); //̲
    if(key==6) setF(-1);  //Ƶ
  }
  if(menu==0){ //ʾ̺Ͳ˵
    if(key) lcd_cls();
	if(key>=1 && key<=7) menu = key, menu2 = 0;
	key = 0;
  }
  if(menu==1){ //LCR()
    pau = 0;
	if(key==1) binLian = (binLian+1)%2; //л
    showR(binLian);
  }
  if(menu==2){
    lcd_goto1(0);
    lcd_puts("up:");  lcd_putc(Vga[0]+48);
    lcd_puts(" dw:"); lcd_putc(Vga[2]+48);
  }
  if(menu==3){ //ֶ
    pau = 1;
	if(key==1) setGain2();//
	if(key==2) { };
    if(key==3) K3=~K3;    //л±
    if(key==4) set902();  //λת
    lcd_goto1(0);
    lcd_puts(" xw="); lcd_putc(xw+48);      //λ
    lcd_puts(" K3="); lcd_putc(K3?49:48);   //K3״̬
    lcd_puts(" Ga="); lcd_putc(curGain+48); //
    lcd_goto2(0);
    if(nn%32==0) lcd_int(getAD10(),5);
  }
  if(menu==7){ //ƫ
	code char *csR[15]   = {
    "Z0 : 20", "Z1 : 20","Z2 : 20",
    "R1X: 20", "R2X: 1k", "R3X:10k", "R4X:.1M", "G1X:3k3", "G2X:10k", 
    "R1 : 20", "R2 : 1k", "R3 :10k", "R4 :.1M", "G1 :3k3", "G2 :10k"};
    char *p,bc=1, feqD=1,rngD=1;
	static char kc=0, mo=0;
    if(menu2==0)  p = cs.zo+0,      feqD=0, rngD=2; //100HzУ׼,10ŷ
    if(menu2==1)  p = cs.zo+1,      feqD=1, rngD=2; //1kHzУ׼,10ŷ
    if(menu2==2)  p = cs.zo+2,      feqD=2, rngD=2; //7.8kHzУ׼,10ŷ
    if(menu2==3)  p = cs.J+0,       feqD=2, rngD=0; //VI任λУ׼,20
    if(menu2==4)  p = cs.J+1,       feqD=2, rngD=1; //VI任λУ׼,1k
    if(menu2==5)  p = cs.J+2,       feqD=2, rngD=2; //VI任λУ׼,10k
    if(menu2==6)  p = cs.J+3,       feqD=2, rngD=3; //VI任λУ׼,100k
    if(menu2==7)  p = &cs.j1,       feqD=2, rngD=1; //˷3λУ׼,3.3kŷ
    if(menu2==8)  p = &cs.j2,       feqD=2, rngD=1; //˷10λУ׼,10kŷ
    if(menu2==9)  p = cs.R+0, bc=2, feqD=1, rngD=0; //VI任ģֵУ׼,20ŷ
    if(menu2==10) p = cs.R+1, bc=2, feqD=1, rngD=1; //VI任ģֵУ׼,1kŷ
    if(menu2==11) p = cs.R+2, bc=2, feqD=1, rngD=2; //VI任ģֵУ׼,10kŷ
    if(menu2==12) p = cs.R+3, bc=2, feqD=1, rngD=3; //VI任ģֵУ׼,100kŷ
    if(menu2==13) p = &cs.g1, bc=2, feqD=1, rngD=1; //˷3У׼,2kŷ
    if(menu2==14) p = &cs.g2, bc=2, feqD=1, rngD=1; //˷10У׼,10kŷ
    if(key==1) *p += bc; //X
    if(key==2) *p -= bc; //R
    if(key==3) { cs_RW(1); setF(feqK); } //L
    if(key==4) *p = 0;   //C
	if(key==5) { if(menu2==0) menu2=14; else menu2--; mo=0; }
	if(key==6) { if(menu2==14)menu2=0;  else menu2++; mo=0; }
	if(key==7) mo = (mo+1)%2;
	if(key==4){ //ָĬֵ
	  if(++kc==5){
	   kc = 0;
       cs.j1 = 16, cs.j2 = 18;
       cs.g1 = 0,  cs.g2 = 0;
       cs.zo[0] = 20;
       cs.zo[1] = 19;
       cs.zo[2] = 14;
       cs.J[0] = cs.J[1] = cs.J[2] = 0, cs.J[3] = 20;
       cs.R[0] = cs.R[1] = cs.R[2] = cs.R[3] = 0;
	  }
	}
	else { if(key) kc=0; }
	//ʾ
	if(mo){
	 if(feqD!=feqK) setF(feqD);
	 if(rngD!=rng)  setRng(rngD);
     showR(1);
	}else{
	  lcd_cls();
      lcd_goto1(0);
      lcd_puts(csR[menu2]); //
      lcd_goto2(0);
      lcd_putf(*p,0,0);
      lcd_puts("X:+ R:-");
    }
  }
  delay(20000);
 }//while end
}
//==========================================================================

