/*************************************
LCR V1.0
xjw01  2011.10
**************************************/
//====================================
#define uchar unsigned char
#define uint  unsigned int
#define ulong  unsigned long
#include <reg52.h>
#include <math.h>

void delay(uint loop) { uint i; for(i=0;i<loop;i++); } //ʱ
void delay2(uint k){ for(;k>0;k--) delay(10000); } //ʱ,k=100ԼӦ1

//========================ADת=============================
sfr P1ASF = 0x9D; //P1ΪģڼĴ(ʹ),λΪ1Ч
sfr ADC_CONTR = 0xBC; //A/DתƼĴ
sfr ADC_res   = 0xBD; //A/DתĴ
sfr ADC_resl  = 0xBE; //A/DתĴ

void set_channel(char channel){
 P1ASF = 1<<channel;
 ADC_CONTR = channel+128; //λǵԴ,3λͨѡ
 delay(1); //״δ򿪵ԴӦӳ٣ʹȶ
}
uint getAD2(){
 ADC_CONTR |= 0x08;             //00001000,ADC_START=1A/D ת
 while ( !(ADC_CONTR & 0x10) ); //ȴA/Dת(ADC_FLAG==0)
 ADC_CONTR &= 0xE7;             //11100111,ADC_FLAG=0, ADC_START=0رA/D ת
 return ADC_res*4 + ADC_resl;
}
/*
uchar get_AD(){
 ADC_CONTR |= 0x08;             //00001000,ADC_START=1A/D ת
 while( !(ADC_CONTR & 0x10) );  //ȴA/Dת(ADC_FLAG==0)
 ADC_CONTR &= 0xE7;             //11100111,ADC_FLAG=0, ADC_START=0رA/D ת
 return ADC_res;
}
*/
uint getAD10() reentrant { //10β
 char i;
 uint c = 0;
 for(i=0;i<10;i++) c += getAD2();
 return c;
}


//============================EEPROWƫ=========================
sfr IAP_data  = 0xC2;
sfr IAP_addrH = 0xC3;
sfr IAP_addrL = 0xC4;
sfr IAP_cmd   = 0xC5;
sfr IAP_trig  = 0xC6;
sfr IAP_contr = 0xC7;
/********************
дֽʱԽԭе1Ϊ0޷0Ϊ1ֻʹò0Ϊ1
Ӧע⣬Ὣ
*********************/
void saEEP(){ //EEP
 IAP_cmd = 0;      //ر
 IAP_contr = 0;    //EEPROM
 IAP_trig = 0;
 IAP_addrL = 255; //öȡַĵֽڣַıҪ
 IAP_addrH = 255; //öȡַĸֽڣַıҪ
}
uchar readEEP(uint k){ //ȡ
 IAP_addrL = k;    //öȡַĵֽڣַıҪ
 IAP_addrH = k>>8; //öȡַĸֽڣַıҪ
 IAP_contr = 0x81; //õȴʱ䣬1MHzȡ72Mȡ63Mȡ56Mȡ412Mȡ320Mȡ224Mȡ130Mȡ0ǰ1ʾIAP
 IAP_cmd = 1;      //ȡֵ1дȡ2ȡ3ʱֽߥ
 IAP_trig = 0x5A;  //5A
 IAP_trig = 0xA5;  //5AA5
 saEEP(); //
 return IAP_data;
}
void writeEEP(uint k, uchar da){ //д
 IAP_data = da;    //
 IAP_addrL = k;    //öȡַĵֽڣַıҪ
 IAP_addrH = k>>8; //öȡַĸֽڣַıҪ
 IAP_contr = 0x81; //õȴʱ䣬1MHzȡ72Mȡ63Mȡ56Mȡ412Mȡ320Mȡ224Mȡ130Mȡ0ǰ1ʾIAP
 IAP_cmd = 2;      //ȡֵ1дȡ2ȡ3ʱֽߥ
 IAP_trig = 0x5A;  //5A
 IAP_trig = 0xA5;  //5AA5
 saEEP(); //
}
void eraseEEP(uint k){ //
 IAP_addrL = k;    //öȡַĵֽڣַıҪ
 IAP_addrH = k>>8; //öȡַĸֽڣַıҪ
 IAP_contr = 0x81; //õȴʱ䣬1MHzȡ72Mȡ63Mȡ56Mȡ412Mȡ320Mȡ224Mȡ130Mȡ0ǰ1ʾIAP
 IAP_cmd = 3;      //ȡֵ1дȡ2ȡ3ʱֽߥ
 IAP_trig = 0x5A;  //5A
 IAP_trig = 0xA5;  //5AA5
 saEEP(); //
}

xdata struct Ida{
 char zo[3];//Ƶµֵ
 char j1;   //λ(3)
 char j2;   //λ(10)
 char J[4];  //λ(V/I任)
 char R[4]; //±۵(20,1k,10k,100k)
 char g1;   //(3)
 char g2;   //(10)
} cs;

void cs_RW(char rw){
 uchar i,*p = &cs;
 if(rw){
  eraseEEP(0);
  for(i=0;i<sizeof(cs);i++) writeEEP(i,p[i]);
 }else{
  for(i=0;i<sizeof(cs);i++) p[i]=readEEP(i);
 }
}

/**********
αͼ
   32
   - 
64| | 128
   -  16
 1| | 8
   _. 4
   2
**********/
uchar code zk[20]={235,136,179,186,216,122,123,168,251,250, 59,201,2,18,50}; //ֿ,0-9,10,11,12,13,14
uchar code zk2[8]={241,25,11,233,27,50,155,107};//p,n,u,m,0,k,M,G

uchar disp[6]={168,251,250}; char cx=-1; //ʾ,cxλ
sfr P1M1=0x91; //P1˿üĴ
sfr P1M0=0x92; //P1˿üĴ
sfr P0M1=0x93; //P0˿üĴ
sfr P0M0=0x94; //P0˿üĴ
sfr P2M1=0x95; //P2˿üĴ
sfr P2M0=0x96; //P2˿üĴ
sfr P3M1=0xB1; //P3˿üĴ
sfr P3M0=0xB2; //P3˿üĴ

sbit ds3=P2^4; //ɨ
sbit ds2=P2^5; //ɨ
sbit ds1=P2^6; //ɨ
sbit ds0=P2^7; //ɨ

sbit spk=P2^3; //
sbit Kb=P2^1; //̿B
sbit Ka=P2^2; //̿A

sbit DDS2=P1^2;//෽
sbit K3=P1^7;
sbit K4=P1^6;
sbit K5=P1^5; //7.8kHz˲
sbit K6=P1^4;
sbit K8=P2^0; //100Hz˲



//==============ַʾ====================
xdata uchar menu=1,menu2=0;
void cls(){ char i; for(i=0;i<6;i++) disp[i]=0; } //
void showDig(long f){ //ʾ
 uchar i;
 cls();
 for(i=0;i<6;i++) { disp[i]=zk[f%10], f/=10; if(!f) break; }
}
void showDig2(float f,char n,char dw){ //ʾ,nLǵλ޿,n=2ʱСʾuλ
  char i,b=0,b2=0,fh=0;
  if(f<0) fh=1,f=-f;
  for(i=0;i<3;i++){ if(f>=1000) f/=1000, b++;  } //3λΪλƶС㣬Ѵת0999,Сĩ
  for(i=0;i<n;i++){ if(f<1)     f*=1000, b--;  } //3λΪλƶС㣬Сת0999,Сĩ
  for(i=0;i<3;i++){ if(f<1000)  f*=10,   b2++; } //С1000ͬСλʹλƵ
  showDig(f+10000); //10000Ϊ˲
  disp[b2] += 4; //С
  if(!dw) return;
  disp[0] = zk2[b+4];  //ʾλ
  if(fh) disp[0] += 4; //ʾ
}



//==============ƵźDDS====================
//PCAؼĴ
sfr CMOD = 0xD9;   //ԴѡƵ
sfr CH = 0xF9;     //PCAļ
sfr CL = 0xE9;     //PCAļ
sfr CCON = 0xD8;   //PCAƼĴ
sfr CCPAM0 = 0xDA; //PCAģ0ģʽĴ
sfr CCPAM1 = 0xDB; //PCAģ1ģʽĴ
sfr CCAP0L = 0xEA; //ģ0Ĵλ
sfr CCAP0H = 0xFA; //ģ0Ĵλ

sbit PPCA  = IP^7;   //PCAжȼ
sbit CCF0  = CCON^0; //PCAģ0жϱ־
sbit CCF1  = CCON^1; //PCAģ1жϱ־
sbit CR = CCON^6;    //PCAʹ

void PWM_init(){ //PCAΪPWM
  CMOD = 2;   //0000 0010 Դѡ,Դȡfosc/2
  CL = CH = 0;
  CCAP0L = CCAP0H = 192; //ռձΪ25%
  //CCPAM0=0x42;//0100 0010,PCAģ0ΪPWMģʽ,ж
  CCPAM0=0x53;//0101 0011,PCAģ0ΪPWMģʽ,жϣ½ж
  PPCA = 1;   //ж
  //CR = 1;   //ʼ
  EA = 1;     //ж
}

uint ph=0, phM=256, feq=1000; //λ,phMλֵ
xdata float feqX=1000; //ʵƵ
uchar code sinB[256]={
 //ѯвװֵжϲ
 255,255,255,255,255,255,254,254,253,252,252,251,250,249,248,247,246,245,243,242,240,239,237,236,234,232,230,229,227,225,222,220,
 218,216,214,211,209,206,204,201,199,196,194,191,188,185,183,180,177,174,171,168,165,162,159,156,153,150,147,144,140,137,134,131,
 128,125,122,119,116,112,109,106,103,100, 97, 94, 91, 88, 85, 82, 79, 76, 73, 71, 68, 65, 62, 60, 57, 55, 52, 50, 47, 45, 42, 40,
  38, 36, 34, 31, 29, 27, 26, 24, 22, 20, 19, 17, 16, 14, 13, 11, 10,  9,  8,  7,  6,  5,  4,  4,  3,  2,  2,  1,  1,  1,  1,  1,
   1,  1,  1,  1,  1,  1,  2,  2,  3,  4,  4,  5,  6,  7,  8,  9, 10, 11, 13, 14, 16, 17, 19, 20, 22, 24, 26, 27, 29, 31, 34, 36,
  38, 40, 42, 45, 47, 50, 52, 55, 57, 60, 62, 65, 68, 71, 73, 76, 79, 82, 85, 88, 91, 94, 97,100,103,106,109,112,116,119,122,125,
 128,131,134,137,140,144,147,150,153,156,159,162,165,168,171,174,177,180,183,185,188,191,194,196,199,201,204,206,209,211,214,216,
 218,220,222,225,227,229,230,232,234,236,237,239,240,242,243,245,246,247,248,249,250,251,252,252,253,254,254,255,255,255,255,255
};
uchar code fbB[256]={ //DDSѯ
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
};
uchar chuX=0; //DDS
void PCAinter(void) interrupt 7 {//PCAж
  uchar x,y;
  CCF0=0; //ж,ⷴж
  x = ph >> 8;     //ضλۼ,ȡ8λ
  y = x + chuX;    //λ
  CCAP0H = sinB[x];//DDS
  DDS2 = fbB[y];   //DDS
  ph += phM;       //λۼ
}
void setDDS(uint f){ //οʱc=(fosc/2)/256=32000000/2/256=62500,Ƶf=c*phM/2^16
 feq = f;
 phM=f*65536.0/62500; //phM=f*2^16/62500
 feqX = 62500.0*phM/65536; //ʵƵ
 ph = 0;              //ƵʱʹζԳ
 if(!f) CR=0; else CR=1;
}

//λƺ
xdata char xw=0; //λ
void set90(char k){ //÷λ
  k %= 4;
  if(k<0) k += 4;
  if(k==0) chuX=0;   //0
  if(k==1) chuX=64;  //90
  if(k==2) chuX=128; //180
  if(k==3) chuX=192; //270
  xw = k;
}
void set902() { set90(xw+1); } //λ

//==============̿ƺ====================
xdata char rng=1; //
void setRng(char k){//л
 if(k==0) Ka=0,Kb=0; //100ŷ
 if(k==1) Ka=0,Kb=1; //1kŷ
 if(k==2) Ka=1,Kb=0; //10kŷ
 if(k==3) Ka=1,Kb=1; //100kŷ
 rng = k;
}
void setRng2(){ setRng( (rng+1)%4); } //̲

//==============ƺ====================
char curGain=1; //ǰ
void setGain(char k){ //õ·
  if(k>3) k=3;
  if(k<0) k=0;
  if(k==0) K4=0,K6=0; //1
  if(k==1) K4=0,K6=1; //3
  if(k==2) K4=1,K6=0; //10
  if(k==3) K4=1,K6=1; //30
  curGain = k;
}
void setGain2(){ setGain((curGain+1)%4); }


//==============LCR====================
xdata int Vxy[4]={0,0,0,0};  //Vxy[Vx1,Vy1,Vx2,Vy2]
xdata char Sxw[4]={0,1,0,1}; //ȷλ
xdata char Vga[4]={1,1,1,1}; //±¼
xdata uchar tim=0,tims=0;
xdata char pau=0; //ͣԶת
#define Vfull 9600
#define gad (9600/30)
uchar mT = 6; //ٶ
//==============Ƶ====================
xdata char feqK=1; //Ƶ
void setF(char k){
  if(k==-1){ //
    k = 0;
    if(feq==100)  k=1;
    if(feq==1000) k=2;
    if(feq==7813) k=0;
  }
  if(k==0) { setDDS(100);   K5=0; K8=1; mT=15; } //Ϊ100Hz
  if(k==1) { setDDS(1000);  K5=0; K8=0; mT=6;  } //Ϊ1kHz
  if(k==2) { setDDS(7813);  K5=1; K8=0; mT=6;  } //Ϊ7.8125kHz
  feqK=k;
  TH1 = 47, TL1 = 171; //Ϊ20ms
  tims = 0;
  tim = 0;
  ph = 0;
}
int absMax(int a,int b){ //ȡֵ
  if(a<0) a = -a;
  if(b<0) b = -b;
  if(b>a) a = b;
  return a;
}
#define avn 4 //ƽ޸
xdata float vq[3][avn]; //ݻ棬ƽ
void LCRcalc(int *v,char *g){ //LCR
  code float ga[4] =  {  1,   3,   9,  27 }; //
  code float dwR[4] = { 20, 1e3, 1e4, 1e5 }; //
  xdata int g12 = (int)cs.g1+cs.g2;          //󲹳
  xdata int j12 = (int)cs.j1+cs.j2;          //λ󲹳
  xdata float JD = 0,cJD, G = 0; //
  xdata float a,b,c,e;
  char i;
  a = +( 1.0*v[2]*v[2] + 1.0*v[3]*v[3] );
  b = -( 1.0*v[0]*v[2] + 1.0*v[1]*v[3] );
  c = -( 1.0*v[2]*v[1] - 1.0*v[0]*v[3] );
  a *= ga[g[0]] / ga[g[2]];
  a /= dwR[rng]*(1+cs.R[rng]/10000.0); //±۵ֵ

  //ɿ浥Ԫλ
  if(g[0] == 1) JD += cs.j1,  G += cs.g1;
  if(g[0] == 2) JD += cs.j2,  G += cs.g2;
  if(g[0] == 3) JD += j12,    G += g12;
  if(g[2] == 1) JD -= cs.j1,  G -= cs.g1;
  if(g[2] == 2) JD -= cs.j2,  G -= cs.g2;
  if(g[2] == 3) JD -= j12,    G -= g12;
  JD -= cs.J[rng];
  JD *= feqX/7813/1000;
  cJD = 1 - JD*JD/2;
  a *= 1+G/10000;   //油
  e = b*cJD - c*JD; //λ
  c = b*JD + c*cJD; //λ
  b = e;
  //
  for(i=1;i<avn;i++){
   vq[0][i] = vq[0][i-1];
   vq[1][i] = vq[1][i-1];
   vq[2][i] = vq[2][i-1];
  }
  vq[0][0]=a, vq[1][0]=b, vq[2][0]=c;
}

void timerInter1(void) interrupt 3 {//T1ж
  char g; int c;
  if(pau) return;
  tims++;
  if(tims>=mT){ //timλ
   tims = 0, tim++;
   if(tim>=4) tim=0;
   c = getAD10();    //ȡѹֵ
   c -= cs.zo[feqK];
   Vxy[tim] = xw<2 ? c : -c; //浱ǰѹ
   Vga[tim] = curGain;       //浱ǰ
   Sxw[tim] += c<0 ? 2 : 0;  //λת(Ԥ´ελֵ)
   Sxw[tim] %= 4;
   if(tim==1||tim==3){ //±л
     //ѹģֵܷӦ˷ŵȣлжϵģֵ
	 if(tim==1) K3=1, c = absMax(Vxy[2],Vxy[3]), g=Vga[2]; //л±
	 if(tim==3) K3=0, c = absMax(Vxy[0],Vxy[1]), g=Vga[0]; //лϱ
     if(c>Vfull) g--;
     else if(c<gad*1 ) g += 3; //27
	 else if(c<gad*3 ) g += 2; //9
	 else if(c<gad*9)  g++;    //3
	 setGain(g);
   }
   set90( Sxw[ (tim+1)%4 ] ); //λת
   LCRcalc(Vxy,Vga);
  }
}

char sfdw=1; //Ƿʾλ
void showR(char xm, char binLian){ //ʾLCR
  char i;
  xdata float a=0,b=0,c=0,e,w;
  for(i=0;i<avn;i++)
    a += vq[0][i]/avn,
    b += vq[1][i]/avn,
    c += vq[2][i]/avn;

  //ѧʾ
  if(!a) { cls(); disp[3]=115;disp[2]=disp[1]=97; return; }
  w = 2*3.1415926*feqX;
  if(!binLian){ //
   e = a;
   if(xm==0){ showDig2(c/e,1,   sfdw); }//ʾXֵ,ʾŷ
   if(xm==1){ showDig2(b/e,1,   sfdw); }//ʾRֵ,ʾŷ
   if(xm==2){
     if(c<0) showDig2(e/c/w,4, sfdw); //ʾCֵ,ʾpF
     else    showDig2(c/e/w,2, sfdw); //ʾLֵ,ʾuH
   }
  }else{ //
   e = (b*b+c*c)/a;
   if(xm==0){ showDig2(e/c,1,   sfdw); }//ʾXֵ,ʾŷ
   if(xm==1){ showDig2(e/b,1,   sfdw); }//ʾRֵ,ʾŷ
   if(xm==2){
     if(c<0) showDig2(c/e/w,4, sfdw);//ʾCֵ,ʾpF
     else    showDig2(e/c/w,2, sfdw);//ʾLֵ,ʾuH
   }
  }
  if(xm==3){ //ʾQֵ
    if(!b) { showDig(9999); return; }
	c = fabs(c/b);
	if     (c>=1000) { showDig(999   ); }
    else if(c>=100 ) { showDig(c     ); }
    else if(c>=10  ) { showDig(c*10  );  disp[1] += 4; }
    else if(c>=1   ) { showDig(c*100 );  disp[2] += 4; }
    else             { showDig(c*1000);  disp[3] += 4; }
  }
}
//void timerInter(void) interrupt 1 {}//T0ж

void showMsg(uchar a){ //ʱϢ
  P0 = ~a;
  ds0=1, ds1=ds2=ds3=0;
  delay2(50);
}
main(){
 uchar i=0,kn=0,key=0;
 uchar dispN=0; //ʾɨ
 uchar spkN=0;  //ʱ
 uint nn=0;
 uchar XRQ=1;
 char binLian=0; //1,0

 delay2(80); //ʱ
 cs_RW(0);   //EEPROM

 TCON=0, TMOD=0x12; //T0ΪԶװʱT1Ϊʱ
 TH1 = 0, TL1 = 0;
 TR1=1;  //T1ʼ
 TR0=0;  //T0ͣ
 ET1=1;  //T1ж
 ET0=1;  //T1ж
 EA=1;   //ж
 PT0=1;  //ȼ


 set_channel(0); //ADתͨ
 P2M0 = 0xFF;    //P2.01234567Ϊ
 P1M0 = 0xFC;    //P1.234567Ϊƻ
 P1M1 = 0x03;    //P1.0Ϊ迹
 
 //עʱ0.5뷽ɶȡcs_RW
 //cs_RW(0); //ȡֵ(ʱʱȷѹɶȡEEPROW)

 PWM_init();//DDSʼ
 set90(2);  //ʼλ
 setRng(1); //ʼ
 setGain(1); //ʼ
 setF(1);    //DDSʼΪ1kHz

 while(1){
  //ʾdisp
  nn++;
  dispN=(++dispN)%4; //ɨƶ
  ds0=ds1=ds2=ds3=0;
  if(dispN==0) ds0=1;
  if(dispN==1) ds1=1;
  if(dispN==2) ds2=1;
  if(dispN==3) ds3=1;
  P0=~disp[dispN]; //ʾ
  //ɨ
  //Ӧ
  //key = (~P3)&0xfc;
  key = ~P3;
  if(key&&kn<255) kn++; else kn=0;
  for(i=0;key;i++) key/=2; key=i;
  if(kn==20) spkN=50; else key=0;   //һʱkeyЧЧspkNʱ
  if(spkN) spkN--, spk=0; else spk=1; //̷
  //˵ϵͳ
  if(key==8) { menu=0; key=0; XRQ=-1;} //˵
  if(menu>=1&&menu<=4){
   if(key==7) setRng2(); //̲
   if(key==6) setF(-1);  //Ƶ
  }
  if(menu==0){ //ʾ̺Ͳ˵
    showDig(10000);
	if(key>=1 && key<=7) menu = key, menu2 = 0;
	key = 0;
  }
  if(menu==1){ //ԶLCR()
    pau = 0;
	if(XRQ==-1) XRQ=1, sfdw=1;
	if(key==4) { //л
       if(binLian) { binLian=0; showMsg(122); } //תΪ
	   else        { binLian=1; showMsg(241); } //תΪ
	}
	if(key==1) { if(XRQ==0) sfdw++; else sfdw=1; XRQ = 0; }
	if(key==2) { if(XRQ==1) sfdw++; else sfdw=1; XRQ = 1; }
	if(key==3) { if(XRQ==2) sfdw++; else sfdw=1; XRQ = 2; }
	if(key==5) XRQ = 3;
	sfdw %= 2;
    showR(XRQ,binLian);
    if(binLian && nn%512<50) { for(i=0;i<4;i++) disp[i] |= 4; }
  }
  if(menu==2){ //ʾ浵λ
    showDig(Vga[0]*100+Vga[2]+10000);
	disp[1]=disp[3]=0;
  }
  if(menu==3){ //ֶ
    pau = 1;
	if(key==1) { setGain2(); showMsg( zk[curGain] );} //
	if(key==2) { };
    if(key==3) { K3=~K3;     showMsg(zk[K3]);       } //л±
    if(key==4) { set902();   showMsg(zk[xw]);       } //λת
    if(nn%64==0) { showDig( getAD10()); disp[1]+=4; }
  }
  if(menu==7){ //ƫ
    char *p,bc=1, feqD=1,rngD=1;
	static char kc=0, mo=0;
    if(menu2==0)  p = cs.zo+0,      feqD=0, rngD=2; //100HzУ׼,10ŷ
    if(menu2==1)  p = cs.zo+1,      feqD=1, rngD=2; //1kHzУ׼,10ŷ
    if(menu2==2)  p = cs.zo+2,      feqD=2, rngD=2; //7.8kHzУ׼,10ŷ
    if(menu2==3)  p = cs.J+0,       feqD=2, rngD=0; //VI任λУ׼,20
    if(menu2==4)  p = cs.J+1,       feqD=2, rngD=1; //VI任λУ׼,1k
    if(menu2==5)  p = cs.J+2,       feqD=2, rngD=2; //VI任λУ׼,10k
    if(menu2==6)  p = cs.J+3,       feqD=2, rngD=3; //VI任λУ׼,100k
    if(menu2==7)  p = &cs.j1,       feqD=2, rngD=1; //˷3λУ׼,3.3k
    if(menu2==8)  p = &cs.j2,       feqD=2, rngD=1; //˷10λУ׼,10k
    if(menu2==9)  p = cs.R+0, bc=2, feqD=1, rngD=0; //VI任ģֵУ׼,20ŷ
    if(menu2==10) p = cs.R+1, bc=2, feqD=1, rngD=1; //VI任ģֵУ׼,1kŷ
    if(menu2==11) p = cs.R+2, bc=2, feqD=1, rngD=2; //VI任ģֵУ׼,10kŷ
    if(menu2==12) p = cs.R+3, bc=2, feqD=1, rngD=3; //VI任ģֵУ׼,100kŷ
    if(menu2==13) p = &cs.g1, bc=2, feqD=1, rngD=1; //˷3У׼,2kŷ
    if(menu2==14) p = &cs.g2, bc=2, feqD=1, rngD=1; //˷10У׼,10kŷ
    if(key==1) *p += bc; //X
    if(key==2) *p -= bc; //R
    if(key==3) { cs_RW(1); setF(feqK); } //L
    if(key==4) *p = 0;   //C
	if(key==5) { if(menu2==0) menu2=14; else menu2--; mo=0; showMsg(menu2<9?zk[menu2]:zk[menu2-6]+4); }
	if(key==6) { if(menu2==14)menu2=0;  else menu2++; mo=0; showMsg(menu2<9?zk[menu2]:zk[menu2-6]+4); }
	if(key==7) mo = (mo+1)%2;
	if(key==4){ //ָĬֵ
	  if(++kc==5){
	   kc = 0;
       cs.j1 = 16, cs.j2 = 18;
       cs.g1 = 0,  cs.g2 = 0;
       cs.zo[0] = 15;
       cs.zo[1] = 17;
       cs.zo[2] = 15;
       cs.J[0] = cs.J[1] = cs.J[2] = 0, cs.J[3] = 20;
       cs.R[0] = cs.R[1] = cs.R[2] = cs.R[3] = 0;
	  }
	}
	else { if(key) kc=0; }
	if(mo){
	 if(feqD!=feqK) setF(feqD);
	 if(rngD!=rng)  setRng(rngD);
	 if(menu2>=3 && menu2<=8) showR(3,1); //ʾQ
	 else showR(1,1); //ʾ
	}else{
	 sfdw = 0;
     showDig(abs(*p));
     if(*p<0) disp[3] = 16;
	}	
  }
  delay(4000);
 }//while end
}


